﻿using System;
using System.Windows.Forms;

using TestLibrary;

namespace TestClient
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.calculateButton.Click += calculateButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 계산하기 - calculateButton_Click(sender, e)

        /// <summary>
        /// 계산하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void calculateButton_Click(object sender, EventArgs e)
        {
            int numerator   = Convert.ToInt32(this.numeratorTextBox.Text  );
            int denominator = Convert.ToInt32(this.denominatorTextBox.Text);

            try
            {
                this.resultTextBox.Text = CalculatorClient.Divide(numerator, denominator).ToString();
            }
            catch(Exception exception)
            {
                MessageBox.Show(this, exception.Message);
            }
        }

        #endregion
    }
}