﻿using System.Configuration;
using System.ServiceModel.Configuration;

using TestLibrary.CalculatorService;

namespace TestLibrary
{
    /// <summary>
    /// 계산기 클라이언트
    /// </summary>
    public static class CalculatorClient
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 구성
        /// </summary>
        private static Configuration _configuration;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Static

        #region 생성자 - CalculatorClient()

        /// <summary>
        /// 생성자
        /// </summary>
        static CalculatorClient()
        {
            _configuration = ConfigurationManager.OpenMappedExeConfiguration
            (
                new ExeConfigurationFileMap { ExeConfigFilename = "TestLibrary.dll.config" },
                ConfigurationUserLevel.None
            );
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 나누기 - Divide(numerator, denominator)

        /// <summary>
        /// 나누기
        /// </summary>
        /// <param name="numerator">분자</param>
        /// <param name="denominator">분모</param>
        /// <returns>몫</returns>
        public static int Divide(int numerator, int denominator)
        {
            using
            (
                ConfigurationChannelFactory<ICalculatorService> channelFactory = new ConfigurationChannelFactory<ICalculatorService>
                (
                    "BasicHttpBinding_ICalculatorService",
                    _configuration,
                    null
                )
            )
            {
                ICalculatorService calculatorService = channelFactory.CreateChannel();

                int result = calculatorService.Divide(numerator, denominator);

                return result;
            }
        }

        #endregion
    }
}